unit XComun;

interface
uses
  Windows, Graphics;

const
  _Lambda = 255;  // 8 bits

type
  XMat = record
    nc,nr : integer;
    dat   : array of array of array of single;
  end;

  procedure UG_BM2Mat(const BM : TBitMap; var Mat : XMat   );
  procedure UG_Mat2BM(const Mat: XMat   ; var BM  : TBitMap);

  procedure UG_CopiaM2M(const MA: XMat; var MB  : XMat);
  procedure UG_SwapM(var MA: XMat; var MB  : XMat);

var
  _kan : array [0..2] of boolean ;
    
implementation

procedure UG_BM2Mat(const BM : TBitMap; var Mat : XMat);
var
  x,y,c  : integer;
begin
  Mat.nc := BM.Width;
  Mat.nr := BM.Height;
  SetLength(Mat.dat, Mat.nc, Mat.nr, 3);

  for y := 0 to Mat.nr - 1 do
    for x := 0 to Mat.nc - 1 do begin
      c := BM.Canvas.Pixels[X,Y];
      Mat.dat[x][y][0] := GetRValue(c);
      Mat.dat[x][y][1] := GetGValue(c);
      Mat.dat[x][y][2] := GetBValue(c);
(*
      Mat.dat[x][y][0] := c and $FF;
      Mat.dat[x][y][1] := (c shr 8) and $FF;
      Mat.dat[x][y][2] := (c shr 16) and $FF;
*)

    end;
end;

procedure UG_Mat2BM(const Mat : XMat; var BM : TBitMap);
var
  x,y   : integer;
  r,g,b : byte;
begin
  BM.Width  := Mat.nc;
  BM.Height := Mat.nr;

  for y := 0 to Mat.nr - 1 do
    for x := 0 to Mat.nc - 1 do begin
      r := round(Mat.dat[x][y][0]);
      g := round(Mat.dat[x][y][1]);
      b := round(Mat.dat[x][y][2]);
      BM.Canvas.Pixels[X,Y] := RGB(r,g,b);
    end;
end;

procedure UG_CopiaM2M(const MA: XMat; var MB  : XMat);
var
  x,y,k   : integer;
begin
  MB.nc := MA.nc;
  MB.nr := MA.nr;
  SetLength(MB.dat,MB.nc,MB.nr,3);

  for k := 0 to 2 do
    for y := 0 to MB.nr - 1 do
      for x := 0 to MB.nc - 1 do
        MB.dat[x][y][k] := MA.dat[x][y][k];

end;

procedure UG_SwapM(var MA: XMat; var MB  : XMat);
var
  MT      : XMat;
begin
  UG_CopiaM2M(MA,MT);
  UG_CopiaM2M(MB,MA);
  UG_CopiaM2M(MT,MB);
end;

begin
  _kan[0]:= true;
  _kan[1]:= true;
  _kan[2]:= true;
end.
